Subject: fix for vulnerability CVE-2008-3547 for OpenTTD 0.3.5 - 0.5.3 (Denial of service (server) via UDP request)
From: OpenTTD developer team <info@openttd.org>
Origin: backport, https://github.com/OpenTTD/OpenTTD/commit/60a6582
Bug:

Buffer overflow in the server requiring remote authenticated users to set long
names for companies and clients before a non-authenticated user can trigger a
buffer overflow and possibly execute arbitrary code.

The buffer overflow is triggered while creating a packet that is never
requested by normal clients and was only added to facilitate external
applications to query the clients and companies on a server. The solution
(trunk r13713) applied in 0.6.2 and later implements a new version of that
protocol that is not vulnerable, however not returning anything at all would
prevent this bug from being triggered while still being technically correct as
the bug happens creating an UDP packet and those are not guaranteed to be
delivered.

The attached patch disables this creating and thus sending the package
completely.


Index: network_udp.c
===================================================================
--- network_udp.c
+++ network_udp.c
@@ -97,6 +97,8 @@
 	Player *player;
 	byte current = 0;
 	int i;
+
+	return; // prevent CVE-2008-3547 from happening

 	// Just a fail-safe.. should never happen
 	if (!_network_udp_server) return;

